
_interrupt:

;DMXPWM.c,26 :: 		void interrupt()
;DMXPWM.c,28 :: 		if (PIR1.RCIF == 1)        // If UART interrupt enabled
	BTFSS      PIR1+0, 5
	GOTO       L_interrupt0
;DMXPWM.c,30 :: 		if(RCSTA.FERR)           // Framing error bit
	BTFSS      RCSTA+0, 2
	GOTO       L_interrupt1
;DMXPWM.c,32 :: 		DMX_Byte = RCREG;      // Update RCREG register and receiving next byte
	MOVF       RCREG+0, 0
	MOVWF      _DMX_Byte+0
;DMXPWM.c,33 :: 		DMX_Channel = 0;       // Start transmition detection
	CLRF       _DMX_Channel+0
	CLRF       _DMX_Channel+1
;DMXPWM.c,34 :: 		}
	GOTO       L_interrupt2
L_interrupt1:
;DMXPWM.c,37 :: 		if((DMX_Channel >= FirstDeviceCh) && (DMX_Channel < LastDeviceCh))
	MOVLW      128
	XORWF      _DMX_Channel+1, 0
	MOVWF      R0
	MOVLW      128
	XORWF      _FirstDeviceCh+1, 0
	SUBWF      R0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt12
	MOVF       _FirstDeviceCh+0, 0
	SUBWF      _DMX_Channel+0, 0
L__interrupt12:
	BTFSS      STATUS+0, 0
	GOTO       L_interrupt5
	MOVLW      128
	XORWF      _DMX_Channel+1, 0
	MOVWF      R0
	MOVLW      128
	XORWF      _LastDeviceCh+1, 0
	SUBWF      R0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt13
	MOVF       _LastDeviceCh+0, 0
	SUBWF      _DMX_Channel+0, 0
L__interrupt13:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt5
L__interrupt9:
;DMXPWM.c,39 :: 		DMX_Array[DMX_Channel - FirstDeviceCh] = RCREG;
	MOVF       _FirstDeviceCh+0, 0
	SUBWF      _DMX_Channel+0, 0
	MOVWF      R0
	MOVF       _FirstDeviceCh+1, 0
	SUBWFB     _DMX_Channel+1, 0
	MOVWF      R1
	MOVLW      _DMX_Array+0
	ADDWF      R0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_DMX_Array+0)
	ADDWFC     R1, 0
	MOVWF      FSR1H
	MOVF       RCREG+0, 0
	MOVWF      INDF1+0
;DMXPWM.c,40 :: 		}
	GOTO       L_interrupt6
L_interrupt5:
;DMXPWM.c,43 :: 		DMX_Byte = RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _DMX_Byte+0
;DMXPWM.c,44 :: 		}
L_interrupt6:
;DMXPWM.c,45 :: 		DMX_Channel++;
	INCF       _DMX_Channel+0, 1
	BTFSC      STATUS+0, 2
	INCF       _DMX_Channel+1, 1
;DMXPWM.c,46 :: 		}
L_interrupt2:
;DMXPWM.c,48 :: 		PIR1.RCIF = 0;            // Reset UART interrupt
	BCF        PIR1+0, 5
;DMXPWM.c,49 :: 		}
L_interrupt0:
;DMXPWM.c,50 :: 		}
L_end_interrupt:
L__interrupt11:
	RETFIE     %s
; end of _interrupt

_Init_PWM:

;DMXPWM.c,52 :: 		void Init_PWM()
;DMXPWM.c,54 :: 		CWG1CON0 = 0;
	CLRF       CWG1CON0+0
;DMXPWM.c,56 :: 		SLRCONA.SLRA0 = 0;
	BCF        SLRCONA+0, 0
;DMXPWM.c,57 :: 		SLRCONA.SLRA1 = 0;
	BCF        SLRCONA+0, 1
;DMXPWM.c,58 :: 		SLRCONA.SLRA2 = 0;
	BCF        SLRCONA+0, 2
;DMXPWM.c,60 :: 		PWM1CON    = 0b11000000;      // Enable PWM Module,  Output Enable Bit ON
	MOVLW      192
	MOVWF      PWM1CON+0
;DMXPWM.c,61 :: 		PWM1CLKCON = 0b00110001;      // Divide by 8, HFINTOSC
	MOVLW      49
	MOVWF      PWM1CLKCON+0
;DMXPWM.c,62 :: 		PWM2CON    = 0b11000000;      // Enable PWM Module,  Output Enable Bit ON
	MOVLW      192
	MOVWF      PWM2CON+0
;DMXPWM.c,63 :: 		PWM2CLKCON = 0b00110001;      // Divide by 8, HFINTOSC
	MOVLW      49
	MOVWF      PWM2CLKCON+0
;DMXPWM.c,64 :: 		PWM3CON    = 0b11000000;      // Enable PWM Module,  Output Enable Bit ON
	MOVLW      192
	MOVWF      PWM3CON+0
;DMXPWM.c,65 :: 		PWM3CLKCON = 0b00110001;      // Divide by 8, HFINTOSC
	MOVLW      49
	MOVWF      PWM3CLKCON+0
;DMXPWM.c,67 :: 		PWM1PH = 0;     // phase
	CLRF       PWM1PH+0
	CLRF       PWM1PH+1
;DMXPWM.c,68 :: 		PWM2PH = 0;
	CLRF       PWM2PH+0
	CLRF       PWM2PH+1
;DMXPWM.c,69 :: 		PWM3PH = 0;
	CLRF       PWM3PH+0
	CLRF       PWM3PH+1
;DMXPWM.c,70 :: 		PWM1DC = 0;     // duty cycle
	CLRF       PWM1DC+0
	CLRF       PWM1DC+1
;DMXPWM.c,71 :: 		PWM2DC = 0;
	CLRF       PWM2DC+0
	CLRF       PWM2DC+1
;DMXPWM.c,72 :: 		PWM3DC = 0;
	CLRF       PWM3DC+0
	CLRF       PWM3DC+1
;DMXPWM.c,73 :: 		PWM1PR = 30000; // period
	MOVLW      48
	MOVWF      PWM1PR+0
	MOVLW      117
	MOVWF      PWM1PR+1
;DMXPWM.c,74 :: 		PWM2PR = 30000;
	MOVLW      48
	MOVWF      PWM2PR+0
	MOVLW      117
	MOVWF      PWM2PR+1
;DMXPWM.c,75 :: 		PWM3PR = 30000;
	MOVLW      48
	MOVWF      PWM3PR+0
	MOVLW      117
	MOVWF      PWM3PR+1
;DMXPWM.c,76 :: 		}
L_end_Init_PWM:
	RETURN
; end of _Init_PWM

_pwmUpdate:

;DMXPWM.c,78 :: 		void pwmUpdate()
;DMXPWM.c,80 :: 		PWMLD.PWM1LDA_A = 1;
	BSF        PWMLD+0, 0
;DMXPWM.c,81 :: 		PWMLD.PWM2LDA_A = 1;
	BSF        PWMLD+0, 1
;DMXPWM.c,82 :: 		PWMLD.PWM3LDA_A = 1;
	BSF        PWMLD+0, 2
;DMXPWM.c,83 :: 		}
L_end_pwmUpdate:
	RETURN
; end of _pwmUpdate

_PWMColor:

;DMXPWM.c,85 :: 		void PWMColor(unsigned char RedVal, unsigned char GreenVal, unsigned char BlueVal)
;DMXPWM.c,87 :: 		RREG = RedVal * 255;
	MOVF       FARG_PWMColor_RedVal+0, 0
	MOVWF      R0
	MOVLW      255
	MOVWF      R4
	CALL       _Mul_8x8_U+0
	MOVF       R0, 0
	MOVWF      PWM2DC+0
	MOVF       R1, 0
	MOVWF      PWM2DC+1
;DMXPWM.c,88 :: 		GREG = GreenVal * 255;
	MOVF       FARG_PWMColor_GreenVal+0, 0
	MOVWF      R0
	MOVLW      255
	MOVWF      R4
	CALL       _Mul_8x8_U+0
	MOVF       R0, 0
	MOVWF      PWM1DC+0
	MOVF       R1, 0
	MOVWF      PWM1DC+1
;DMXPWM.c,89 :: 		BREG = BlueVal * 255;
	MOVF       FARG_PWMColor_BlueVal+0, 0
	MOVWF      R0
	MOVLW      255
	MOVWF      R4
	CALL       _Mul_8x8_U+0
	MOVF       R0, 0
	MOVWF      PWM3DC+0
	MOVF       R1, 0
	MOVWF      PWM3DC+1
;DMXPWM.c,90 :: 		pwmUpdate();
	CALL       _pwmUpdate+0
;DMXPWM.c,91 :: 		}
L_end_PWMColor:
	RETURN
; end of _PWMColor

_InitDMXPort:

;DMXPWM.c,94 :: 		void InitDMXPort()
;DMXPWM.c,96 :: 		SPBRGH = 0;
	CLRF       SPBRGH+0
;DMXPWM.c,97 :: 		SPBRGL = 3;       // Set speed 250000 bps / 16 Mhz)
	MOVLW      3
	MOVWF      SPBRGL+0
;DMXPWM.c,98 :: 		TXSTA.BRGH = 1;   // Set High speed
	BSF        TXSTA+0, 2
;DMXPWM.c,99 :: 		TXSTA.SYNC = 0;   // Enable Asynchronous mode
	BCF        TXSTA+0, 4
;DMXPWM.c,100 :: 		PIE1 = 0;         // Peripheral interrupt enable
	CLRF       PIE1+0
;DMXPWM.c,101 :: 		PIE1.RCIE = 1;    // Enable interrupt on UART receive
	BSF        PIE1+0, 5
;DMXPWM.c,102 :: 		RCSTA.RX9 = 1;    // Enable 9th bit receive
	BSF        RCSTA+0, 6
;DMXPWM.c,103 :: 		DMX_Byte = RCREG; // Read 1st byte from port
	MOVF       RCREG+0, 0
	MOVWF      _DMX_Byte+0
;DMXPWM.c,104 :: 		DMX_Byte = RCREG; // Read 2nd byte from port
	MOVF       RCREG+0, 0
	MOVWF      _DMX_Byte+0
;DMXPWM.c,105 :: 		DMX_Byte = RCREG; // Read 3rd byte from port
	MOVF       RCREG+0, 0
	MOVWF      _DMX_Byte+0
;DMXPWM.c,106 :: 		RCSTA.CREN = 1;   // Enable continuous receive
	BSF        RCSTA+0, 4
;DMXPWM.c,107 :: 		RCSTA.SPEN = 1;   // Serial port enable(configure RX and TX pins as port pins)
	BSF        RCSTA+0, 7
;DMXPWM.c,108 :: 		RCSTA.ADDEN = 0;  // Disable channel detection
	BCF        RCSTA+0, 3
;DMXPWM.c,109 :: 		INTCON.PEIE = 1;  // Enable peripheral interrupts
	BSF        INTCON+0, 6
;DMXPWM.c,110 :: 		INTCON.GIE = 1;   // Enable all interrupts
	BSF        INTCON+0, 7
;DMXPWM.c,111 :: 		}
L_end_InitDMXPort:
	RETURN
; end of _InitDMXPort

_main:

;DMXPWM.c,113 :: 		void main()
;DMXPWM.c,115 :: 		ANSELA = 0b00000000;         // All Analog Inputs Disabled
	CLRF       ANSELA+0
;DMXPWM.c,116 :: 		PORTA  = 0b00000000;         // All Port Pins Off
	CLRF       PORTA+0
;DMXPWM.c,117 :: 		TRISA  = 0b00110000;         // RA5 Setup as Input
	MOVLW      48
	MOVWF      TRISA+0
;DMXPWM.c,118 :: 		OSCCON = 0b01111010;         // Internal 16Mhz Oscillator
	MOVLW      122
	MOVWF      OSCCON+0
;DMXPWM.c,119 :: 		DMX_Channel = 0;             // Set initial channel
	CLRF       _DMX_Channel+0
	CLRF       _DMX_Channel+1
;DMXPWM.c,120 :: 		CM1CON0.C1ON = 0;            // Disable Comparator
	BCF        CM1CON0+0, 7
;DMXPWM.c,121 :: 		INTCON.GIE = 1;              // Enable Global Interrupts
	BSF        INTCON+0, 7
;DMXPWM.c,122 :: 		INTCON.PEIE = 1;             // Enable Peripheral Interrupts
	BSF        INTCON+0, 6
;DMXPWM.c,124 :: 		APFCON.RXDTSEL = 1;          // Sets up RX Input as RA5
	BSF        APFCON+0, 7
;DMXPWM.c,125 :: 		APFCON.P1SEL = 0;            // Sets up RA1 as PWM Input
	BCF        APFCON+0, 0
;DMXPWM.c,126 :: 		Init_PWM();                  // Initialize PWM Setup
	CALL       _Init_PWM+0
;DMXPWM.c,127 :: 		InitDMXPort();               // Initialize DMX Serial Setup
	CALL       _InitDMXPort+0
;DMXPWM.c,129 :: 		DMXStartingAddress = 1;      // Set starting DMX channel number.
	MOVLW      1
	MOVWF      _DMXStartingAddress+0
;DMXPWM.c,130 :: 		FirstDeviceCh = DMXStartingAddress;
	MOVLW      1
	MOVWF      _FirstDeviceCh+0
	CLRF       _FirstDeviceCh+1
;DMXPWM.c,131 :: 		LastDeviceCh = FirstDeviceCh + Channels; // Calculate last DMX channel number.
	MOVLW      4
	MOVWF      _LastDeviceCh+0
	MOVLW      0
	MOVWF      _LastDeviceCh+1
;DMXPWM.c,135 :: 		while (1 == 1)
L_main7:
;DMXPWM.c,137 :: 		PWMColor(DMX_Array[0], DMX_Array[1], DMX_Array[2]);
	MOVF       _DMX_Array+0, 0
	MOVWF      FARG_PWMColor_RedVal+0
	MOVF       _DMX_Array+1, 0
	MOVWF      FARG_PWMColor_GreenVal+0
	MOVF       _DMX_Array+2, 0
	MOVWF      FARG_PWMColor_BlueVal+0
	CALL       _PWMColor+0
;DMXPWM.c,138 :: 		}
	GOTO       L_main7
;DMXPWM.c,139 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
